#include <stdlib.h>
#include <uf_defs.h>
#include <uf_obj.h>
#include <uf_obj_types.h>
#include <uf_object_types.h>
#include <uf_part.h>
#include <uf_assem.h>
#include <uf_modl.h>
#include "calcproto.h"

/**********************************************************************
* calc_model 
*    This routine controls the creation of the geometry of the 
* calculator.  The current work part is saved and the components are
* made the work part before the component geometry creation routine
* is called.  The work part is changed back to the saved work part and
* the array of button components are created.
*
*   revisions 
*   rv   date        who     reason for change 
*   00   01NOV95     J_P                   
*   01   01AUG97     J_P     Removed unneeded variables
*   02   14FEB03     DKF     Changed color setting calls to new method
*
* input 
*   top_inst     Tag of top half component of calculator 
*   bottom_inst  Tag of bottom half component 
*   button_inst  Tag of button component 
*
* output 
*   holes        List of photocell and lcd slots features
*   calc_model   0 = success, > 0 = error 
*  
**********************************************************************/


    int calc_model(tag_t top_inst, tag_t bottom_inst,
                     tag_t button_inst, uf_list_p_t holes)
{
/******************** Routine variable declaration  *******************/
    int flag;       /* results from functions */

    tag_t
        wpart,      /* part associated with component */
        parent;     /* current work part;  root of the assembly */

/******************** Beginning of Executable code *********************/

/*XXX Set the variable 'parent' to the current work part */

/*XXX Obtain the top piece part tag (wpart) using ask_child_of_instance
 * (check the return tag validity).  */

    if( NULL_TAG == wpart ) return( 1 );
/* XXX Change the display part to the
 * top piece part.  Trap return code)
 */
	flag =
    if( flag ) return( 2 );

/* Create the interpart expressions for the work part.  Check return
 * code.  Use UF_MODL_update after creating the expressions.
 */

/*XXX Set the solid body creation color to white */

	/* Call the routine that creates the top half object and holes. */
/*    flag = calc_model_top(holes); */
    if(flag) return (flag);

/*XXX Obtain the bottom piece part tag (wpart) using ask_child_of_instance
 * (check the return tag validity). */

    if( wpart == NULL_TAG ) return( 1 );

/*XXX Change the display part to the bottom piece part. Trap return code)
 */
	flag =
    if( flag ) return( 2 );

/* Create the interpart expressions for the work part.  Check return
 * code.  Use UF_MODL_update after creating the expressions.
 */

/*XXX Set the solid body creation color to yellow */

/* Call the routine that creates the bottom half object. */
/*    flag = calc_model_bottom(); */
    if(flag) return (flag);

/*XXX Obtain the button piece part tag (wpart) using ask_child_of_instance
 * (check the return tag validity). */

    if( wpart == NULL_TAG ) return( 1 );

/*XXX Change the display part to the button piece part. Trap return code)
 */
	flag =
    if( flag ) return( 2 );

/*XXX Set the solid body creation color to cyan */

/* Create the interpart expressions for the work part.  Check return
 * code.  Use UF_MODL_update after creating the expressions.
 */

/*XXX Set the solid body creation color to cyan */

/* Call the routine that creates the button object. */
/*    flag = calc_model_button(); */
    if(flag) return (flag);

/*XXX Set the display part to 'parent' (original work/display part) */

/* Call the routine to create the master component array. */
/*    flag = calc_comp_array( button_inst ); */
    if(flag) return (flag);

    return (0);
}
