/*===========================================================================
 
                  Copyright (c) 1997 Electronic Data Systems Corporation
                             Unpublished - All rights reserved
 
 ===========================================================================*/
#include <stdio.h>
#include <uf.h>
#include <uf_defs.h>
#include <uf_part.h>


/******************************************************************************/
/*       Define variables used in this set of routines.                       */

/******************************************************************************/
  
/******************************************************************************/
/*    Protoype internal routines.  Make then static, if possible.             */
   
/******************************************************************************/


/******************************************************************************/
/*      Define Global Variable and declare externals                          */

/******************************************************************************/


/******************************************************************************
*  This routine opens the part passed via the charater string parameter.  The
*  routine returns the return code of the UF_PART_open routine, which indicates
*  the status of the root part (if an assembly) or the single part file.  The
*  routine checks and prints the status of the return codes for components but
*  these are not returned to the calling routine.  Any space malloced by the
*  open routine (for errors) is freed before returning.
******************************************************************************/
int openprt ( char *opname )
{
/************************ Routine variable declaration  ***********************/
    int
        irc,        /* Return code from called routine (passed back to caller)*/
        i;          /* Loop Counter */
    tag_t
        part;       /* Parameter for UF_PART_open call */
    UF_PART_load_status_t
        e_stat;     /* Parameter for UF_PART_open call */


/************************ Begining of Executable code *************************/

    irc = UF_PART_open( opname, &part, &e_stat );

    if ( e_stat.n_parts ) {
        printf("Number of component parts w/open error statuses = %d\n"
            , e_stat.n_parts );

		for( i=0; i<e_stat.n_parts; i++ ) {
			printf(" File %s has open status %d\n", e_stat.file_names[i], 
								e_stat.statuses[i] );
		}

        UF_free( e_stat.statuses );
        UF_free_string_array( e_stat.n_parts, e_stat.file_names );
    }
    return( irc );
}
