/* include file calcproto.h */
#include <uf.h>
#include <uf_ui.h>
#include <uf_defs.h>
#include <uf_modl.h>
#include <stdio.h>


/* prototypes for functions in the calculator program */
    int calc_part(void);
    int calc_setup( int *, double *, double * );
	void calc_set_style_dialog( int , int );
	int calc_assem( tag_p_t, tag_p_t, tag_p_t );
	int calc_expr(int, double, double);
	int calc_interpart_expr(void);
	int calc_model(tag_t, tag_t, tag_t, uf_list_p_t);
    int calc_model_top( uf_list_p_t );
	int calc_model_top_holes(tag_t , uf_list_p_t );
	int calc_model_bottom (void);
	int calc_model_button (void);
	int calc_comp_array( tag_t );
	int calc_dimension( void );
	int calc_dimension_top( void );
	int calc_dimension_bottom( void );
	int calc_dimension_button( void );
	int calc_dimension_button_edges( tag_t *, int * ); 
	int calc_dimension_top_edges( tag_t *, int * );
	int calc_drawing( char * );
	int calc_drawing_views(char *,int );
	int calc_edit(uf_list_p_t, tag_t, tag_t, tag_t );
/*	int calc_plot(char * );*/
	int ug_set_wcs_to_view(char * );  


/* utilities */

#define UF_CALL(X) (report_error( __FILE__, __LINE__, #X, (X)))
static int report_error( char *file, int line, char *call, int irc)
{
if (irc)
    {
char 
	err[133],
	msg[133];

sprintf(msg, "*** ERROR code %d at line %d in %s:\n+++ ",
irc, line, file);
UF_get_fail_message(irc, err);
/*  NOTE:  UF_print_syslog is new in V18 */
UF_print_syslog(msg, FALSE);
UF_print_syslog(err, FALSE);
UF_print_syslog("\n", FALSE);
UF_print_syslog(call, FALSE);
UF_print_syslog(";\n", FALSE);

if (!UF_UI_open_listing_window())
        {
UF_UI_write_listing_window(msg);
UF_UI_write_listing_window(err);
UF_UI_write_listing_window("\n");
UF_UI_write_listing_window(call);
UF_UI_write_listing_window(";\n");
        }
    }

return(irc);
}